############################################################
#
# źղեΥͥ륢ϥɥ
#
############################################################
package plugin::thumbnail::Handler;
use strict;
use plugin::thumbnail::Inline;
use plugin::thumbnail::Admin;
use plugin::thumbnail::Delete;
use Image::Info qw(image_info);
use Image::Thumbnail;

#===========================================================
# 󥹥ȥ饯
#===========================================================
sub new {
	my $class = shift;
	my $self = {};
	return bless $self,$class;
}

#===========================================================
# μ¹
#===========================================================
sub do_action {
	my $self = shift;
	my $wiki = shift;
	my $cgi = $wiki->get_CGI;
	
	my $page = $cgi->param("page");
	if($page eq ""){
		$page = $wiki->config("frontpage");
	}
	$wiki->set_title($page,1);
	
	my $file = $cgi->param("file");
	if($file eq ""){
		return $wiki->error("ե뤬ꤵƤޤ");
	}
	unless($wiki->can_show($page)){
		return $wiki->error("ڡλȸ¤ޤ");
	}
	
	my $filename = plugin::thumbnail::Inline::create_image_filename($wiki, $page, $file);
	unless(-f $filename){
		#unlinks;
		plugin::thumbnail::Delete::delete_of_file($wiki, $page, $file);
		return $wiki->error("ե뤬ߤĤޤ");
	}
	
	my $image_info = image_info($filename);
	if(exists $image_info->{error}){
		return $wiki->error("եǤϤޤ");
	}
	my $contenttype = $image_info->{file_media_type};
	
	my $admin = new plugin::thumbnail::Admin;
	$admin->load_config($wiki);
	
	my $size = $cgi->param("size");
	if($size eq ""){
		$size = $admin->{conf}->{default_size};
	}
	unless(exists $admin->{param}->{$size}){
		return $wiki->error("꤬ŬڤǤϤޤ");
	}
	
	my $cachename = plugin::thumbnail::Inline::create_cache_filename($wiki, $page, $file, $size);
	if(not -e $cachename or -M $filename < -M $cachename){
		make_thumbnail($filename, $cachename, $admin->{param}->{$size}, $image_info);
	}
	
	open(DATA, $cachename) or die $!;
	print "Content-Type: $contenttype\n";
#	if ($pagename =~ m![^ -~]!) {
#		# ܸޤե̾򥨥
#		print "Content-Disposition: inline;filename*=iso-2022-jp''".
#			uri_escape(&Jcode::convert("$file",'jis'))."\n\n";
#	} else {
#		print "Content-Disposition: inline;filename=\"$file\"\n\n";
#	}
	print "Content-Disposition: inline;filename=\"".&Jcode::convert($file,'sjis')."\"\n\n";
	
	binmode(DATA);
	while(read(DATA, $_, 16384)){ print $_; }
	close(DATA);
	
	exit();
}

sub make_thumbnail {
	my $src = shift;
	my $dist = shift;
	my $param = shift;
	my $info = shift;
	
	# ̾
	my $width = $info->{width};
	my $height = $info->{height};
	my ($ratio , $max, $x, $y);
	$ratio = $param->{ratio} / 100 *($width > $height ? $width : $height)
		if ($param->{ratio});
	$max = $param->{max}
		if ($param->{max});
	$x = $param->{x} * ($width > $height ? 1 : $height/$width)
		if ($param->{x});
	$y = $param->{y} * ($width > $height ? $width/$height : 1)
		if ($param->{y});
	my $size = int( (sort {$a<=>$b} grep {$_} ($ratio, $max, $x, $y))[$param->{priorty} eq "max" ? -1 : 0] );
	
	my $t = new Image::Thumbnail(
		size		=> $size,
		create		=> 1,
		inputpath	=> $src,
		outputpath	=> $dist,
	);
}

1;
